lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    path('friends', friend_list)
    # TODO Add friends path using friend_list Views
]

lab_2/urls.py
from django.urls import path
from .views import index,xml,json

urlpatterns = [
    #Menambahkan path sesuai dengan urls
    path('', index, name='index'),
    path('xml', xml, name='xml'),
    path('json', json, name='json'),
]

lab_3/urls.py
from django.urls import path
from .views import index,add_friend

app_name="lab_3"
urlpatterns = [
    #Menambahkan path sesuai dengan urls
    path('', index, name='index'),
    path('add', add_friend, name='add_friend'),
]

lab_4/urls.py
from django.urls import path
from .views import index, add_note,note_list

app_name="lab_4"
urlpatterns = [
    #Menambahkan path sesuai dengan urls
    path('', index, name='index'),
    path('add', add_note, name='add_note'),
    path('note', note_list, name="note_list")
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
from lab_1.views import index as index_lab1

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include(lab_1)),
    path('lab-2/', include(lab_2)),
    path('lab-3/', include(lab_3)),
    path('lab-4/', include(lab_4)),
    re_path(r'^$', index_lab1, name='index')
]

lab_1/models.py
from django.db import models

# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.CharField(max_length=20)
    DOB = models.DateField()
    # TODO Implement missing attributes in Friend model

lab_2/models.py
from django.db import models

class Note(models.Model):
    #Membuat model Note
    To = models.CharField(max_length=30)
    From = models.CharField(max_length=30)
    Title = models.CharField(max_length=30)
    Message = models.TextField()

lab_3/models.py
from django.db import models

# Create your models here.

lab_4/models.py
from django.db import models

# Create your models here.

lab_3/forms.py
from django import forms
from lab_1.models import Friend

class DateInput(forms.DateInput):
    #Membuat class untuk date widget
    input_type='date'
class FriendForm(forms.ModelForm):
    class Meta:
        #Mengambil model Friend
        model=Friend
        #Melist semua fields yang perlu diisi
        fields = [
            'name',
            'npm',
            'DOB'
        ]
        #Mengapply widget date ke DOB
        widgets={
            'DOB':DateInput()
        }

lab_4/forms.py
from django import forms
from lab_2.models import Note


class NoteForm(forms.ModelForm):
    class Meta:
        #Mengambil model Friend
        model=Note
        #Melist semua fields yang perlu diisi
        fields = [
            'To',
            'From',
            'Title',
            'Message'
        ]

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Christopher Bagas Laiputra'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2002,7,29)  # TODO Implement this, format (Year, Month, Date)
npm = 2006595822  # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all()
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.shortcuts import render
from .models import Note
from django.http.response import HttpResponse
from django.core import serializers 

def index(request):
    #Mereturn isi semua object Note dengan template html
    note = Note.objects.all()
    response = {'notes': note}
    return render(request, 'lab_2.html', response)

def xml(request):
    #Mengubah object Note menjadi xml
    data = Note.objects.all()
    data = serializers.serialize('xml', data)
    return HttpResponse(data, content_type="application/xml")

def json(request):
    #Mengubah object Note menjadi json
    data = Note.objects.all()
    data = serializers.serialize('json', data)
    return HttpResponse(data, content_type="application/json")

lab_3/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.decorators import login_required
from lab_1.models import Friend
from .forms import FriendForm

@login_required(login_url="/admin/login")#Untuk authorization
def index(request):
    friends = Friend.objects.all() #Ambil semua object Friend
    response = {'friends': friends} #Membuat dict untuk response
    return render(request, 'lab3_index.html', response) #Return ke dalam bentuk html

@login_required(login_url="/admin/login")
def add_friend(request):
    friends_form=FriendForm() #Membuat FriendForm
    response={'friend_form':friends_form} #Membuat dict untuk response
    
    if request.method=="POST": #Jika respnse method POST get isi dari request post 
        friends_form=FriendForm(request.POST)
        if friends_form.is_valid(): #Jika semua field terisi, save ke database
            friends_form.save()
            return redirect('/lab-3') #Redirect ke lab-3

    return render(request,'lab3_form.html', response) #Return FriendForm ke dalam bentuk html

lab_4/views.py
from django.shortcuts import render, redirect
from lab_2.models import Note
from django.http.response import HttpResponse
from .forms import NoteForm

def index(request):
    #Mereturn isi semua object Note dengan template html
    note = Note.objects.all()
    response = {'notes': note}
    return render(request, 'lab4_index.html', response)
def add_note(request):
    notes_form=NoteForm() #Membuat NoteForm
    response={'note_form':notes_form} #Membuat dict untuk response
    
    if request.method=="POST": #Jika respnse method POST get isi dari request post 
        notes_form=NoteForm(request.POST)
        if notes_form.is_valid(): #Jika semua field terisi, save ke database
            notes_form.save()
            return redirect('/lab-4') #Redirect ke lab-3

    return render(request,'lab4_form.html', response) #Return NoteForm ke dalam bentuk html

def note_list(request):
    #Mereturn isi semua object Note dengan template html
    note = Note.objects.all()
    response = {'notes': note}
    return render(request, 'lab4_note_list.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% for i in friends %}
      <tr>
        <td>{{i.name}}</td>
        <td>{{i.npm}}</td>
        <td>{{i.DOB}}</td>
      </tr>
      {% endfor %}
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab_2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>To</th>
        <th>From</th>
        <th>Title</th>
        <th>Message</th>
      </tr>
      <!-- Mencetak semua atribut Note sesuai dengan kolom tabel -->
      {% for i in notes %}
      <tr>
        <td>{{i.To}}</td>
        <td>{{i.From}}</td>
        <td>{{i.Title}}</td>
        <td>{{i.Message}}</td>
      </tr>
      {% endfor %}
    </table>
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <title>Friend Form</title>
</head>
<body>
    <form action="" method="POST">
        <h1>Add Your Friends</h1>
        {% csrf_token %}
        <table>
            {{friend_form}}
        </table>
        <br>
        <button type="submit">Submit</button>
    </form>
</body>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% for i in friends %}
      <tr>
        <td>{{i.name}}</td>
        <td>{{i.npm}}</td>
        <td>{{i.DOB}}</td>
      </tr>
      {% endfor %}
    </table>
  </body>
</html>

lab_4/templates/lab4_form.html
<!DOCTYPE html>
{% load static %}
{% load widget_tweaks %}
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <title>Friend Form</title>
    <link rel="stylesheet" href="{% static 'css/form.css' %}" />
    <link href='https://unpkg.com/boxicons@2.0.7/css/boxicons.min.css' rel='stylesheet'>
</head>
<body>
    <input type="checkbox" id="check">
    <label for="check">
      <i class='bx bx-menu' id="btn" ></i>
      <i class='bx bx-x'id='cancel' ></i>
    </label>
    <div class="title">
      <div class="inner">
        <div class="logo-title">
        <i class='bx bxl-django' ></i>
        <a href="{% url 'index' %}">Lab PBP</a>
      </div>
      </div>
    </div>
    <nav class="sidebar">
      <div class="logo-details">
        <span class="logo"><i class='bx bxl-django' ></i></span>
          <span class="logo_name">Lab Django</span>
      </div>
      <ul class="menu">
        <li>
          <a href="{% url 'lab_3:index' %}">
            <span class="icon">
            <i class='bx bx-group'></i></span>
            <span class="links_name">Friends</span>
          </a>
        </li>
        <ul class="submenu">
          <li>
            <a href="{% url 'lab_3:add_friend' %}">
              <span class="subicon"><i class='bx bxs-book-content'></i></span>
             <span class="sublinks_name">Form</span>
            </a>
          </li>
          <li>
           <a href="{% url 'lab_3:index' %}">
            <span class="subicon"><i class='bx bx-table' ></i></span>
            <span class="sublinks_name">Table</span>
           </a>
         </li>
        </ul> 
        <li>
         <a href="{% url 'lab_4:index' %}">
           <span class="icon">
          <i class='bx bxs-id-card' ></i></span>
           <span class="links_name">Note</span>
         </a>
      
       </li>
      <ul class="submenu">
        <li>
          <a href="{% url 'lab_4:add_note' %}">
            <span class="subicon"><i class='bx bxs-book-content'></i></span>
           <span class="sublinks_name">Form</span>
          </a>
        </li>
        <li>
         <a href="{% url 'lab_4:index' %}">
          <span class="subicon"><i class='bx bx-table' ></i></span>
          <span class="sublinks_name">Table</span>
         </a>
       </li>
       <li>
         <a href="{% url 'lab_4:note_list' %}">
          <span class="subicon"><i class='bx bx-id-card' ></i></span>
          <span class="sublinks_name">Card</span>
         </a>
       </li>
      </ul> 
       <li>
         <a href="#">
          <span class="icon">
          <i class='bx bx-log-in' ></i></span>
          <span class="links_name">Login</span>
         </a>
       </li>
      </ul>
    </nav>
    <div class="isi">
        <span class="title-table">Notes Form</span>
        <form action="" method="POST">
            {% csrf_token %}
            <div class="field">
                <label class="label">To</label>
                <div class="control">
                  {% render_field note_form.To class="input" placeholder="Reciever Name" %}
                </div>
            </div>
            <div class="field">
                <label class="label">From</label>
                <div class="control">
                  {% render_field note_form.From class="input" placeholder="Sender name" %}
                </div>
            </div>
            <div class="field">
                <label class="label">Title</label>
                <div class="control">
                  {% render_field note_form.Title class="input" placeholder="Enter Title"  %}
                </div>
            </div>
            <div class="field">
                <label class="label">Message</label>
                <div class="control">
                    {% render_field note_form.Message rows="10" placeholder="Your message" class+="textarea" %}
                </div>
            </div>
            <div class="buttons is-centered">
                <button type="submit">Submit</button>
            </div>
        </form>
    </div>
</body>
</html>

lab_4/templates/lab4_index.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes</title>
    <link rel="stylesheet" href="{% static 'css/style.css' %}" />
    <link href='https://unpkg.com/boxicons@2.0.7/css/boxicons.min.css' rel='stylesheet'>
    
  </head>
  <body>
    <input type="checkbox" id="check">
    <label for="check">
      <i class='bx bx-menu' id="btn" ></i>
      <i class='bx bx-x'id='cancel' ></i>
    </label>
    <div class="title">
      <div class="inner">
        <div class="logo-title">
        <i class='bx bxl-django' ></i>
        <a href="{% url 'index' %}">Lab PBP</a>
      </div>
      </div>
    </div>
    <nav class="sidebar">
      <div class="logo-details">
        <span class="logo"><i class='bx bxl-django' ></i></span>
          <span class="logo_name">Lab Django</span>
      </div>
      <ul class="menu">
        <li>
          <a href="{% url 'lab_3:index' %}">
            <span class="icon">
            <i class='bx bx-group'></i></span>
            <span class="links_name">Friends</span>
          </a>
        </li>
        <ul class="submenu">
          <li>
            <a href="{% url 'lab_3:add_friend' %}">
              <span class="subicon"><i class='bx bxs-book-content'></i></span>
             <span class="sublinks_name">Form</span>
            </a>
          </li>
          <li>
           <a href="{% url 'lab_3:index' %}">
            <span class="subicon"><i class='bx bx-table' ></i></span>
            <span class="sublinks_name">Table</span>
           </a>
         </li>
        </ul> 
        <li>
         <a href="{% url 'lab_4:index' %}">
           <span class="icon">
          <i class='bx bxs-id-card' ></i></span>
           <span class="links_name">Note</span>
         </a>
       </li>
      <ul class="submenu">
        <li>
          <a href="{% url 'lab_4:add_note' %}">
            <span class="subicon"><i class='bx bxs-book-content'></i></span>
           <span class="sublinks_name">Form</span>
          </a>
        </li>
        <li>
         <a href="{% url 'lab_4:index' %}">
          <span class="subicon"><i class='bx bx-table' ></i></span>
          <span class="sublinks_name">Table</span>
         </a>
       </li>
       <li>
         <a href="{% url 'lab_4:note_list' %}">
          <span class="subicon"><i class='bx bx-id-card' ></i></span>
          <span class="sublinks_name">Card</span>
         </a>
       </li>
      </ul> 
       <li>
         <a href="#">
          <span class="icon">
          <i class='bx bx-log-in' ></i></span>
          <span class="links_name">Login</span>
         </a>
       </li>
      </ul>
    </nav>
    
    <div class="isi">
      <span class="title-table">Notes Table</span>
      <table>
        <thead>
          <tr>
            <th>To</th>
            <th>From</th>
            <th>Title</th>
            <th>Message</th>
          </tr>
        </thead>
        <!-- Mencetak semua atribut Note sesuai dengan kolom tabel  -->
        <tbody>
          {% for i in notes %}
          <tr>
            <td>{{i.To}}</td>
            <td>{{i.From}}</td>
            <td>{{i.Title}}</td>
            <td>{{i.Message}}</td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
  </body>

</html>

lab_4/templates/lab4_note_list.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes</title>
    <link rel="stylesheet" href="{% static 'css/card.css' %}" />
    <link href='https://unpkg.com/boxicons@2.0.7/css/boxicons.min.css' rel='stylesheet'>

  </head>
  <body>
    <input type="checkbox" id="check">
    <label for="check">
      <i class='bx bx-menu' id="btn" ></i>
      <i class='bx bx-x'id='cancel' ></i>
    </label>
    <div class="title">
      <div class="inner">
        <div class="logo-title">
        <i class='bx bxl-django' ></i>
        <a href="{% url 'index' %}">Lab PBP</a>
      </div>
      </div>
    </div>
    <div class="sidebar">
      <div class="logo-details">
        <span class="logo"><i class='bx bxl-django' ></i></span>
          <span class="logo_name">Lab Django</span>
      </div>
      <ul class="menu">
        <li>
          <a href="{% url 'lab_3:index' %}">
            <span class="icon">
            <i class='bx bx-group'></i></span>
            <span class="links_name">Friends</span>
          </a>
        </li>
        <ul class="submenu">
          <li>
            <a href="{% url 'lab_3:add_friend' %}">
              <span class="subicon"><i class='bx bxs-book-content'></i></span>
             <span class="sublinks_name">Form</span>
            </a>
          </li>
          <li>
           <a href="{% url 'lab_3:index' %}">
            <span class="subicon"><i class='bx bx-table' ></i></span>
            <span class="sublinks_name">Table</span>
           </a>
         </li>
        </ul> 
        <li>
         <a href="{% url 'lab_4:index' %}">
           <span class="icon">
          <i class='bx bxs-id-card' ></i></span>
           <span class="links_name">Note</span>
         </a>
      
       </li>
      <ul class="submenu">
        <li>
          <a href="{% url 'lab_4:add_note' %}">
            <span class="subicon"><i class='bx bxs-book-content'></i></span>
           <span class="sublinks_name">Form</span>
          </a>
        </li>
        <li>
         <a href="{% url 'lab_4:index' %}">
          <span class="subicon"><i class='bx bx-table' ></i></span>
          <span class="sublinks_name">Table</span>
         </a>
       </li>
       <li>
         <a href="{% url 'lab_4:note_list' %}">
          <span class="subicon"><i class='bx bx-id-card' ></i></span>
          <span class="sublinks_name">Card</span>
         </a>
       </li>
      </ul> 
       <li>
         <a href="#">
          <span class="icon">
          <i class='bx bx-log-in' ></i></span>
          <span class="links_name">Login</span>
         </a>
       </li>
      </ul>
    </div>
    <div class="isi">
      {% for i in notes %}
      <div class="card">
        <div class="container">
          <h2 class="card-title">{{i.Title}}</h2>
          <h4 class="card-to-from">From:  {{i.From}}</h4>
          <h4 class="card-to-from">To:  {{i.To}}</h4>
          <p class="card-text">{{i.Message}}</p>
        </div>
      </div>
      {% endfor %}
    </div>